searchNodes=[{"ref":"CubicBezier.html","title":"CubicBezier","type":"module","doc":"Elixir port of the the JavaScript port of Webkit implementation of CSS cubic-bezier(p1x.p1y,p2x,p2y) by http://mck.me http://svn.webkit.org/repository/webkit/trunk/Source/WebCore/platform/graphics/UnitBezier.h https://gist.github.com/mckamey/3783009"},{"ref":"CubicBezier.html#calculate_coefficients/1","title":"CubicBezier.calculate_coefficients/1","type":"function","doc":"Defines a cubic-bezier curve given the middle two control points. NOTE: first and last control points are implicitly (0,0) and (1,1). @param p1x {number} X component of control point 1 @param p1y {number} Y component of control point 1 @param p2x {number} X component of control point 2 @param p2y {number} Y component of control point 2"},{"ref":"CubicBezier.html#control_points/1","title":"CubicBezier.control_points/1","type":"function","doc":"Return a control points tuple based on the easing equation name. See: https://gist.github.com/terkel/4377409"},{"ref":"CubicBezier.html#sample_curve_derivative_x/2","title":"CubicBezier.sample_curve_derivative_x/2","type":"function","doc":"@param t {number} parametric timing value @return {number}"},{"ref":"CubicBezier.html#sample_curve_x/2","title":"CubicBezier.sample_curve_x/2","type":"function","doc":"@param t {number} parametric timing value @return {number}"},{"ref":"CubicBezier.html#sample_curve_y/2","title":"CubicBezier.sample_curve_y/2","type":"function","doc":"@param t {number} parametric timing value @return {number}"},{"ref":"CubicBezier.html#solve/3","title":"CubicBezier.solve/3","type":"function","doc":"Given x (a float between 0.0 and 1.0), compute the y; which essentially acts a &quot;speed&quot;. Optioanally, a duration can be provided which can provide greater accuracy. The default is 400 (ms), which is a common animation / transition duration."},{"ref":"CubicBezier.html#solve_curve_x/3","title":"CubicBezier.solve_curve_x/3","type":"function","doc":"Given an x value, find a parametric value it came from. @param x {number} value of x along the bezier curve, 0.0 &lt;= x &lt;= 1.0 @param epsilon {number} accuracy limit of t for the given x @return {number} the t value corresponding to x"},{"ref":"CubicBezier.html#solve_epsilon/1","title":"CubicBezier.solve_epsilon/1","type":"function","doc":"The epsilon value we pass to UnitBezier::solve given that the animation is going to run over |dur| seconds. The longer the animation, the more precision we need in the timing function result to avoid ugly discontinuities. http://svn.webkit.org/repository/webkit/trunk/Source/WebCore/page/animation/AnimationBase.cpp"},{"ref":"CubicBezier.html#solve_with_epsilon/3","title":"CubicBezier.solve_with_epsilon/3","type":"function","doc":"@param x {number} the value of x along the bezier curve, 0.0 &lt;= x &lt;= 1.0 @param epsilon {number} the accuracy of t for the given x @return {number} the y value along the bezier curve Renamed from solve"},{"ref":"readme.html","title":"CubicBezier","type":"extras","doc":"CubicBezier Elixir port of the CSS cubic-bezier(p1x, p1y, p2x, p2y) timing function."},{"ref":"readme.html#installation","title":"CubicBezier - Installation","type":"extras","doc":"The package can be installed by adding cubic_bezier to your list of dependencies in mix.exs: def deps do [ {:cubic_bezier, &quot;~&gt; 0.0.2&quot;} ] end"},{"ref":"readme.html#why","title":"CubicBezier - Why?","type":"extras","doc":"Let&#39;s say you want to &quot;tween&quot; (animate / transition) an object&#39;s position. You might take the travel distance, and divide by the steps (&quot;frames&quot;) of your tween. On every frame, you&#39;d increment the object&#39;s position. This would be the equivelant of a linear Cubic Bezier; and it tends to look / feel very unnatural. To make the movement feel more natural, you&#39;d use an &quot;easing equation&quot;. To further make the animation feel more natural, you&#39;d want to compute the object&#39;s position about 60 times per second (60 fps). This will smooth out the position changes to make it feel more fluid. The combination is natural and fluid tweens!"},{"ref":"getting-started.html","title":"Getting Started","type":"extras","doc":"Getting Started CubicBezier aims to replicate the CubicBezier timing function found in CSS used with the animation-timing-function property and the transition-timing-function property. A Cubic Bezier curve is defined by four points P0, P1, P2, and P3. P0 and P3 are the start and the end of the curve and, in CSS these points are fixed as the coordinates are ratios. P0 is (0, 0) and represents the initial time and the initial state, P3 is (1, 1) and represents the final time and the final state. Since x is always between 0 and 1, and y is almost always also between 0 and 1, it is useful to treat them as percentages. Where x is the percentage of time that has elapsed in your animation / transition, and y is the percentage your object(s) should have moved between their start and end positions."},{"ref":"getting-started.html#syntax","title":"Getting Started - Syntax","type":"extras","doc":"You can use atoms to represent common control points, or pass a control point tuple. The examples below are equivelant: CubicBezier.solve(0.25, :ease_out_quad) CubicBezier.solve(0.25, {0.250, 0.460, 0.450, 0.940}) This will return a y position of ~0.45, given an x of 0.25. Ease-Out-Quad is fast at first, and slow towards the end."}]